## mingw-w64-itk-5.4.2-4.src.tar.zst

=== Modules/ThirdParty/DoubleConversion/CMakeLists.txt ===
project(ITKDoubleConversion)
set(ITKDoubleConversion_THIRD_PARTY 1)

option(ITK_USE_SYSTEM_DOUBLECONVERSION
  "Use an outside build of double-conversion" OFF)

mark_as_advanced(ITK_USE_SYSTEM_DOUBLECONVERSION)

if(ITK_USE_SYSTEM_DOUBLECONVERSION)
  find_package(double-conversion 3.1.6 REQUIRED)
  get_target_property(ITKDoubleConversion_INCLUDE_DIRS double-conversion::double-conversion INTERFACE_INCLUDE_DIRECTORIES)
  get_target_property(ITKDoubleConversion_LIBRARIES double-conversion::double-conversion LOCATION)
else()
  set(ITKDoubleConversion_INCLUDE_DIRS
    ${ITKDoubleConversion_SOURCE_DIR}/src
    ${ITKDoubleConversion_BINARY_DIR}/src/double-conversion)
  set(ITKDoubleConversion_LIBRARIES itkdouble-conversion)
endif()

itk_module_impl()

=== Modules/ThirdParty/libLBFGS/CMakeLists.txt ===
project(ITKLIBLBFGS)
set(ITKLIBLBFGS_THIRD_PARTY 1)


#option(ITK_USE_SYSTEM_LIBLBFGS "Use an outside build of LIBLBFGS." OFF)
#mark_as_advanced(ITK_USE_SYSTEM_LIBLBFGS)

#if(ITK_USE_SYSTEM_LIBLBFGS)
#  find_package(LIBLBFGS REQUIRED)
#  set(ITKLIBLBFGS_SYSTEM_INCLUDE_DIRS)
#  set(ITKLIBLBFGS_LIBRARIES LIBLBFGS)
#  set(ITKLIBLBFGS_SYSTEM_LIBRARY_DIRS "${LIBLBFGS_LIBRARY_DIR}")
#  set(ITKLIBLBFGS_NO_SRC 1)
#else()

set(ITKLIBLBFGS_INCLUDE_DIRS ${ITKLIBLBFGS_SOURCE_DIR}/include )
set(ITKLIBLBFGS_LIBRARIES itklbfgs)

#endif()

itk_module_impl()

=== Modules/Core/Common/src/CMakeLists.txt ===
include(GetGitRevisionDescription)
get_git_head_revision(GIT_CONFIG_REFSPEC GIT_CONFIG_SHA1)
git_describe(GIT_VERSION_DESC)
git_head_date(GIT_CONFIG_DATE)
git_head_localmods(GIT_LOCAL_MODIFICATIONS)
if(GIT_LOCAL_MODIFICATIONS MATCHES ".*files changed.*")
  set(GIT_LOCAL_MODIFICATIONS " (with uncommitted code modifications ${GIT_LOCAL_MODIFICATIONS})")
endif()

string(TIMESTAMP CONFIGURE_DATE "%Y-%m-%d %H:%M" UTC)

## MAKE_MAP_ENTRY is a macro to facilitate placing items in the itk::BuildInformation class
##                /--------------------------_---------------------------_-------------------------------------------------/
##                |    KEY                   |    VALUE                  | Description of value                            |
##                \--------------------------\---------------------------\-------------------------------------------------\
set(MAPPING_VALUES
    "
  MAKE_MAP_ENTRY( \"PROJECT_URL\",           \"https://www.itk.org\",      \"The URL of project.\"                     );
  MAKE_MAP_ENTRY( \"VERSION\",               \"${ITK_VERSION}\"    ,      \"The version at configuration time.\"      );
  MAKE_MAP_ENTRY( \"CONFIGURE_DATE\",        \"${CONFIGURE_DATE}\",       \"The date of configuration.\"              );

  MAKE_MAP_ENTRY( \"GIT_CONFIG_SHA1\",       \"${GIT_CONFIG_SHA1}${GIT_LOCAL_MODIFICATIONS}\",
                                                                               \"The git HEAD SHA1 has at configuration.\");
  MAKE_MAP_ENTRY( \"GIT_CONFIG_REFSPEC\",    \"${GIT_CONFIG_REFSPEC}\",   \"The git HEAD ref spec.\"                  );
  MAKE_MAP_ENTRY( \"GIT_CONFIG_DATE\",       \"${GIT_CONFIG_DATE}\",      \"The git HEAD date\"                       );
  MAKE_MAP_ENTRY( \"GIT_VERSION_DESC\",      \"${GIT_VERSION_DESC}\",     \"The git HEAD version tag-commits-hash\"   );

  MAKE_MAP_ENTRY( \"CMAKE_VERSION\",         \"${CMAKE_VERSION}\",        \"The version of cmake used to configure.\");
  MAKE_MAP_ENTRY( \"CMAKE_GENERATOR\",       \"${CMAKE_GENERATOR}\",      \"The generator used for building.\"        );
  MAKE_MAP_ENTRY( \"CMAKE_BUILD_TYPE\",      \"${CMAKE_BUILD_TYPE}\",     \"The build type requested.\"               );

  MAKE_MAP_ENTRY( \"CMAKE_C_COMPILER_ID\",   \"${CMAKE_C_COMPILER_ID}\",  \"The C compiler ID used for building.\"    );
  MAKE_MAP_ENTRY( \"CMAKE_C_COMPILER_VERSION\",   \"${CMAKE_C_COMPILER_VERSION}\",
                                                                          \"The C compiler version used for building.\"    );
  MAKE_MAP_ENTRY( \"CMAKE_C_COMPILER\",      \"${CMAKE_C_COMPILER}\",     \"The C compiler.\"                       );
  MAKE_MAP_ENTRY( \"CMAKE_C_FLAGS\",         \"${CMAKE_C_FLAGS} ${CMAKE_CXX_FLAGS_${CMAKE_BUILD_TYPE}}\",
                                                                          \"The C compiler flags.\"                 );

  MAKE_MAP_ENTRY( \"CMAKE_CXX_STANDARD\",    \"${CMAKE_CXX_STANDARD}\",   \"The CXX standard specified.\"             );
  MAKE_MAP_ENTRY( \"CMAKE_CXX_COMPILER_ID\", \"${CMAKE_CXX_COMPILER_ID}\",\"The CXX compiler ID used for building.\"  );
  MAKE_MAP_ENTRY( \"CMAKE_CXX_COMPILER_VERSION\",   \"${CMAKE_CXX_COMPILER_VERSION}\",
                                                                          \"The CXX compiler version used for building.\"  );
  MAKE_MAP_ENTRY( \"CMAKE_CXX_COMPILER\",    \"${CMAKE_CXX_COMPILER}\",   \"The CXX compiler.\"                       );
  MAKE_MAP_ENTRY( \"CMAKE_CXX_FLAGS\",       \"${CMAKE_CXX_FLAGS} ${CMAKE_CXX_FLAGS_${CMAKE_BUILD_TYPE}}\",
                                                                          \"The CXX compiler flags.\"                 );
")

configure_file(itkBuildInformation.cxx.in ${ITKCommon_BINARY_DIR}/itkBuildInformation.cxx)
#[COPYONLY] [ESCAPE_QUOTES] [@ONLY]
#[NEWLINE_STYLE [UNIX|DOS|WIN32|LF|CRLF] ])

set(ITKCommon_SRCS
    ${ITKCommon_BINARY_DIR}/itkBuildInformation.cxx
    itkCommonEnums.cxx
    itkMemoryProbesCollectorBase.cxx
    itkCreateObjectFunction.cxx
    itkLogger.cxx
    itkLogOutput.cxx
    itkLoggerOutput.cxx
    itkProgressAccumulator.cxx
    itkTotalProgressReporter.cxx
    itkNumericTraits.cxx
    itkHexahedronCellTopology.cxx
    itkIndent.cxx
    itkEventObject.cxx
    itkFileOutputWindow.cxx
    itkSimpleFilterWatcher.cxx
    itkNumericTraitsVectorPixel.cxx
    itkObject.cxx
    itkQuadrilateralCellTopology.cxx
    itkIterationReporter.cxx
    itkMemoryProbe.cxx
    itkTextOutput.cxx
    itkNumericTraitsTensorPixel2.cxx
    itkNumericTraitsFixedArrayPixel2.cxx
    itkProcessObject.cxx
    itkStreamingProcessObject.cxx
    itkSpatialOrientationAdapter.cxx
    itkRealTimeInterval.cxx
    itkOctreeNode.cxx
    itkNumericTraitsFixedArrayPixel.cxx
    itkMultiThreaderBase.cxx
    itkPlatformMultiThreader.cxx
    itkMetaDataObject.cxx
    itkMetaDataDictionary.cxx
    itkDataObject.cxx
    itkThreadLogger.cxx
    itkNumericTraitsTensorPixel.cxx
    itkCommand.cxx
    itkNumericTraitsPointPixel.cxx
    itkLightObject.cxx
    itkStdStreamLogOutput.cxx
    itkLightProcessObject.cxx
    itkRegion.cxx
    itkImageIORegion.cxx
    itkImageSourceCommon.cxx
    itkImageToImageFilterCommon.cxx
    itkImageRegionSplitterBase.cxx
    itkImageRegionSplitterSlowDimension.cxx
    itkImageRegionSplitterDirection.cxx
    itkImageRegionSplitterMultidimensional.cxx
    itkVersion.cxx
    itkNumericTraitsRGBAPixel.cxx
    itkRealTimeClock.cxx
    itkMetaDataObjectBase.cxx
    itkCovariantVector.cxx
    itkMemoryUsageObserver.cxx
    itkMersenneTwisterRandomVariateGenerator.cxx
    itkLoggerBase.cxx
    itkNumericTraitsCovariantVectorPixel.cxx
    itkProgressReporter.cxx
    itkExceptionObject.cxx
    itkMultipleLogOutput.cxx
    itkQuadraticTriangleCellTopology.cxx
    itkTimeProbesCollectorBase.cxx
    itkSmapsFileParser.cxx
    itkTriangleCellTopology.cxx
    itkVector.cxx
    itkRealTimeStamp.cxx
    itkDirectory.cxx
    itkLoggerManager.cxx
    itkTimeProbe.cxx
    itkNumericTraitsRGBPixel.cxx
    itkTimeStamp.cxx
    itkSingleton.cxx
    itkTetrahedronCellTopology.cxx
    itkThreadedIndexedContainerPartitioner.cxx
    itkObjectFactoryBase.cxx
    itkFloatingPointExceptions.cxx
    itkOutputWindow.cxx
    itkNumericTraitsDiffusionTensor3DPixel.cxx
    itkEquivalencyTable.cxx
    itkXMLFileOutputWindow.cxx
    itkXMLFilterWatcher.cxx
    itkStoppingCriterionBase.cxx
    itkCompensatedSummation.cxx
    itkArrayOutputSpecialization.cxx
    itkNumberToString.cxx
    itkRandomVariateGeneratorBase.cxx
    itkMath.cxx
    itkProgressTransformer.cxx
    itkSymmetricEigenAnalysis.cxx
    itkExtractImageFilter.cxx
    itkLoggerThreadWrapper.cxx
    itkFrustumSpatialFunction.cxx
    itkObjectStore.cxx
    itkGaussianDerivativeOperator.cxx
    itkSpatialOrientation.cxx)

if(WIN32)
  list(APPEND ITKCommon_SRCS itkWin32OutputWindow.cxx)
endif()
if(ITK_USE_WIN32_THREADS OR ITK_USE_PTHREADS)
  list(
    APPEND
    ITKCommon_SRCS
    itkPoolMultiThreader.cxx
    itkThreadPool.cxx)
endif()

if(ITK_DYNAMIC_LOADING)
  list(APPEND ITKCommon_SRCS itkDynamicLoader.cxx)
endif()

if(ITK_USE_TBB)
  list(APPEND ITKCommon_SRCS itkTBBMultiThreader.cxx)
endif()

# Prevent optimization from affecting the floating point calculation.
if(CMAKE_CXX_COMPILER MATCHES "^icc")
  if(WIN32)
    set_source_files_properties(itkCompensatedSummation.cxx PROPERTIES COMPILE_FLAGS /fp precise)
  else()
    set_source_files_properties(itkCompensatedSummation.cxx PROPERTIES COMPILE_FLAGS -fp-model precise)
  endif()
elseif(CMAKE_COMPILER_IS_GNUCXX)
  # -fno-associative-math appears to only be present in GCC 4.3 onwards.
  include(CheckCXXCompilerFlag)
  check_cxx_compiler_flag(-fno-associative-math gcc_has_no_associative_math)
  if(gcc_has_no_associative_math)
    set_source_files_properties(itkCompensatedSummation.cxx PROPERTIES COMPILE_FLAGS -fno-associative-math)
  else()
    set_source_files_properties(itkCompensatedSummation.cxx PROPERTIES COMPILE_FLAGS -fno-unsafe-math-optimizations)
  endif()
elseif(MSVC)
  set_source_files_properties(itkCompensatedSummation.cxx PROPERTIES COMPILE_FLAGS -fp:precise)
endif()

### generating libraries
itk_module_add_library(ITKCommon ${ITKCommon_SRCS})

target_link_libraries(
  ITKCommon
  LINK_PUBLIC
  itksys
  ITKVNLInstantiation)

if(UNIX)
  target_link_libraries(
    ITKCommon
    LINK_PUBLIC
    ${CMAKE_THREAD_LIBS}
    -lm)
  if(ITK_DYNAMIC_LOADING)
    target_link_libraries(ITKCommon LINK_PUBLIC ${CMAKE_DL_LIBS})
  endif()
endif()

if(ITK_USE_TBB)
  # https://software.intel.com/en-us/node/506139
  # The macro TBB_DEPRECATED controls deprecated features.
  #      Define it to 0 to remove deprecated Intel® Threading Building Blocks (Intel® TBB) 2.1 interfaces.
  target_compile_definitions(ITKCommon PUBLIC TBB_DEPRECATED=0)
  # The macro TBB_USE_CAPTURED_EXCEPTION controls rethrow of exceptions within the library.
  #      Define TBB_USE_CAPTURED_EXCEPTION=0 to request rethrow of the exact exception.
  target_compile_definitions(ITKCommon PUBLIC TBB_USE_CAPTURED_EXCEPTION=0)
endif()

=== Modules/Core/Transform/test/CMakeLists.txt ===
itk_module_test()
set(ITKTransformTests
    itkFixedCenterOfRotationAffineTransformTest.cxx
    itkAffineTransformTest.cxx
    itkScaleSkewVersor3DTransformTest.cxx
    itkComposeScaleSkewVersor3DTransformTest.cxx
    itkEuler3DTransformTest.cxx
    itkCenteredRigid2DTransformTest.cxx
    itkEuler2DTransformTest.cxx
    itkRigid3DTransformTest.cxx
    itkScaleVersor3DTransformTest.cxx
    itkTransformTest.cxx
    itkRigid3DPerspectiveTransformTest.cxx
    itkSimilarity2DTransformTest.cxx
    itkTranslationTransformTest.cxx
    itkIdentityTransformTest.cxx
    itkCenteredAffineTransformTest.cxx
    itkRigid2DTransformTest.cxx
    itkScaleLogarithmicTransformTest.cxx
    itkQuaternionRigidTransformTest.cxx
    itkScaleTransformTest.cxx
    itkSimilarity3DTransformTest.cxx
    itkAzimuthElevationToCartesianTransformTest.cxx
    itkCenteredEuler3DTransformTest.cxx
    itkTransformsSetParametersTest.cxx
    itkBSplineDeformableTransformTest.cxx
    itkBSplineDeformableTransformTest2.cxx
    itkBSplineDeformableTransformTest3.cxx
    itkBSplineTransformTest.cxx
    itkBSplineTransformTest2.cxx
    itkBSplineTransformTest3.cxx
    itkBSplineTransformInitializerTest1.cxx
    itkBSplineTransformInitializerTest2.cxx
    itkVersorRigid3DTransformTest.cxx
    itkVersorTransformTest.cxx
    itkSplineKernelTransformTest.cxx
    itkCompositeTransformTest.cxx
    itkTransformCloneTest.cxx
    itkMultiTransformTest.cxx
    itkTestTransformGetInverse.cxx
    itkTransformGeometryImageFilterTest.cxx)

createtestdriver(ITKTransform "${ITKTransform-Test_LIBRARIES}" "${ITKTransformTests}")
itk_add_test(
  NAME
  itkFixedCenterOfRotationAffineTransformTest
  COMMAND
  ITKTransformTestDriver
  itkFixedCenterOfRotationAffineTransformTest)
itk_add_test(
  NAME
  itkAffineTransformTest
  COMMAND
  ITKTransformTestDriver
  itkAffineTransformTest)
itk_add_test(
  NAME
  itkScaleSkewVersor3DTransformTest
  COMMAND
  ITKTransformTestDriver
  itkScaleSkewVersor3DTransformTest)
itk_add_test(
  NAME
  itkComposeScaleSkewVersor3DTransformTest
  COMMAND
  ITKTransformTestDriver
  itkComposeScaleSkewVersor3DTransformTest)
itk_add_test(
  NAME
  itkEuler3DTransformTest
  COMMAND
  ITKTransformTestDriver
  itkEuler3DTransformTest)
itk_add_test(
  NAME
  itkCenteredRigid2DTransformTest
  COMMAND
  ITKTransformTestDriver
  itkCenteredRigid2DTransformTest)
itk_add_test(
  NAME
  itkEuler2DTransformTest
  COMMAND
  ITKTransformTestDriver
  itkEuler2DTransformTest)
itk_add_test(
  NAME
  itkRigid3DTransformTest
  COMMAND
  ITKTransformTestDriver
  itkRigid3DTransformTest)
itk_add_test(
  NAME
  itkScaleVersor3DTransformTest
  COMMAND
  ITKTransformTestDriver
  itkScaleVersor3DTransformTest)
itk_add_test(
  NAME
  itkTransformTest
  COMMAND
  ITKTransformTestDriver
  itkTransformTest)
itk_add_test(
  NAME
  itkRigid3DPerspectiveTransformTest
  COMMAND
  ITKTransformTestDriver
  itkRigid3DPerspectiveTransformTest)
itk_add_test(
  NAME
  itkSimilarity2DTransformTest
  COMMAND
  ITKTransformTestDriver
  itkSimilarity2DTransformTest)
itk_add_test(
  NAME
  itkTranslationTransformTest
  COMMAND
  ITKTransformTestDriver
  itkTranslationTransformTest)
itk_add_test(
  NAME
  itkIdentityTransformTest
  COMMAND
  ITKTransformTestDriver
  itkIdentityTransformTest)
itk_add_test(
  NAME
  itkCenteredAffineTransformTest
  COMMAND
  ITKTransformTestDriver
  itkCenteredAffineTransformTest)
itk_add_test(
  NAME
  itkRigid2DTransformTest
  COMMAND
  ITKTransformTestDriver
  itkRigid2DTransformTest)
itk_add_test(
  NAME
  itkScaleLogarithmicTransformTest
  COMMAND
  ITKTransformTestDriver
  itkScaleLogarithmicTransformTest)
itk_add_test(
  NAME
  itkQuaternionRigidTransformTest
  COMMAND
  ITKTransformTestDriver
  itkQuaternionRigidTransformTest)
itk_add_test(
  NAME
  itkScaleTransformTest
  COMMAND
  ITKTransformTestDriver
  itkScaleTransformTest)
itk_add_test(
  NAME
  itkSimilarity3DTransformTest
  COMMAND
  ITKTransformTestDriver
  itkSimilarity3DTransformTest)
itk_add_test(
  NAME
  itkAzimuthElevationToCartesianTransformTest
  COMMAND
  ITKTransformTestDriver
  itkAzimuthElevationToCartesianTransformTest
  0
  0
  1.0
  1.0
  1.0
  0.0)
itk_add_test(
  NAME
  itkCenteredEuler3DTransformTest
  COMMAND
  ITKTransformTestDriver
  itkCenteredEuler3DTransformTest)
itk_add_test(
  NAME
  itkTransformsSetParametersTest
  COMMAND
  ITKTransformTestDriver
  itkTransformsSetParametersTest)

## Tests for ITKv3 version of BSplineDeformableTransforms
itk_add_test(
  NAME
  itkBSplineDeformableTransformTest
  COMMAND
  ITKTransformTestDriver
  itkBSplineDeformableTransformTest)
itk_add_test(
  NAME
  itkBSplineDeformableTransformTest2
  COMMAND
  ITKTransformTestDriver
  --compare
  DATA{Baseline/itkBSplineDeformableTransformTest2PixelCentered.png}
  ${ITK_TEST_OUTPUT_DIR}/itkBSplineDeformableTransformTest2PixelCentered.png
  itkBSplineDeformableTransformTest2
  DATA{Baseline/BSplineDeformationTransformDisplacements5.txt}
  ${ITK_EXAMPLE_DATA_ROOT}/DiagonalLines.png
  ${ITK_EXAMPLE_DATA_ROOT}/DiagonalLines.png
  ${ITK_TEST_OUTPUT_DIR}/itkBSplineDeformableTransformTest2PixelCentered.png
  ${ITK_TEST_OUTPUT_DIR}/itkBSplineDeformableTransformTest2DeformationFieldPixelCentered.mhd
  1)
itk_add_test(
  NAME
  itkBSplineDeformableTransformTest3
  COMMAND
  ITKTransformTestDriver
  --compare
  DATA{Baseline/itkBSplineDeformableTransformTest3PixelCentered.png}
  ${ITK_TEST_OUTPUT_DIR}/itkBSplineDeformableTransformTest3PixelCentered.png
  itkBSplineDeformableTransformTest2
  DATA{Baseline/BSplineDeformationTransformDisplacements3.txt}
  ${ITK_EXAMPLE_DATA_ROOT}/DiagonalLines.png
  ${ITK_EXAMPLE_DATA_ROOT}/DiagonalLines.png
  ${ITK_TEST_OUTPUT_DIR}/itkBSplineDeformableTransformTest3PixelCentered.png
  ${ITK_TEST_OUTPUT_DIR}/itkBSplineDeformableTransformTest3DeformationFieldPixelCentered.mhd
  2)
itk_add_test(
  NAME
  itkBSplineDeformableTransformTest4
  COMMAND
  ITKTransformTestDriver
  --compare
  DATA{Baseline/itkBSplineDeformableTransformTest4PixelCentered.png}
  ${ITK_TEST_OUTPUT_DIR}/itkBSplineDeformableTransformTest4PixelCentered.png
  itkBSplineDeformableTransformTest2
  DATA{Baseline/BSplineDeformationTransformDisplacements1.txt}
  ${ITK_EXAMPLE_DATA_ROOT}/DiagonalLines.png
  ${ITK_EXAMPLE_DATA_ROOT}/DiagonalLines.png
  ${ITK_TEST_OUTPUT_DIR}/itkBSplineDeformableTransformTest4PixelCentered.png
  ${ITK_TEST_OUTPUT_DIR}/itkBSplineDeformableTransformTest4DeformationFieldPixelCentered.mhd
  3)
itk_add_test(
  NAME
  itkBSplineDeformableTransformTest5
  COMMAND
  ITKTransformTestDriver
  --compare
  DATA{Baseline/itkBSplineDeformableTransformTest5PixelCentered.png}
  ${ITK_TEST_OUTPUT_DIR}/itkBSplineDeformableTransformTest5PixelCentered.png
  itkBSplineDeformableTransformTest3
  DATA{Baseline/BSplineDeformationTransformDisplacements1.txt}
  ${ITK_EXAMPLE_DATA_ROOT}/DiagonalLines.png
  ${ITK_EXAMPLE_DATA_ROOT}/DiagonalLines.png
  ${ITK_TEST_OUTPUT_DIR}/itkBSplineDeformableTransformTest5PixelCentered.png
  ${ITK_TEST_OUTPUT_DIR}/itkBSplineDeformableTransformTest5DeformationFieldPixelCentered.mhd
  0)
itk_add_test(
  NAME
  itkBSplineDeformableTransformTest6
  COMMAND
  ITKTransformTestDriver
  --compare
  DATA{Baseline/itkBSplineDeformableTransformTest5PixelCentered.png}
  ${ITK_TEST_OUTPUT_DIR}/itkBSplineDeformableTransformTest6PixelCentered.png
  itkBSplineDeformableTransformTest3
  DATA{Baseline/BSplineDeformationTransformDisplacements1.txt}
  ${ITK_EXAMPLE_DATA_ROOT}/DiagonalLines.png
  ${ITK_EXAMPLE_DATA_ROOT}/DiagonalLines.png
  ${ITK_TEST_OUTPUT_DIR}/itkBSplineDeformableTransformTest6PixelCentered.png
  ${ITK_TEST_OUTPUT_DIR}/itkBSplineDeformableTransformTest6DeformationFieldPixelCentered.mhd
  1)
itk_add_test(
  NAME
  itkBSplineDeformableTransformTest7
  COMMAND
  ITKTransformTestDriver
  --compare
  DATA{Baseline/itkBSplineDeformableTransformTest5PixelCentered.png}
  ${ITK_TEST_OUTPUT_DIR}/itkBSplineDeformableTransformTest7PixelCentered.png
  itkBSplineDeformableTransformTest3
  DATA{Baseline/BSplineDeformationTransformDisplacements1.txt}
  ${ITK_EXAMPLE_DATA_ROOT}/DiagonalLines.png
  ${ITK_EXAMPLE_DATA_ROOT}/DiagonalLines.png
  ${ITK_TEST_OUTPUT_DIR}/itkBSplineDeformableTransformTest7PixelCentered.png
  ${ITK_TEST_OUTPUT_DIR}/itkBSplineDeformableTransformTest7DeformationFieldPixelCentered.mhd
  2)

## Tests for ITKv4 version of BSplineTransforms
itk_add_test(
  NAME
  itkBSplineTransformTest
  COMMAND
  ITKTransformTestDriver
  itkBSplineTransformTest)
itk_add_test(
  NAME
  itkBSplineTransformTest2
  COMMAND
  ITKTransformTestDriver
  --compare
  DATA{Baseline/itkBSplineTransformTest2PixelCentered.png}
  ${ITK_TEST_OUTPUT_DIR}/itkBSplineTransformTest2PixelCentered.png
  itkBSplineTransformTest2
  ${ITK_EXAMPLE_DATA_ROOT}/BSplineDisplacements5.txt
  ${ITK_EXAMPLE_DATA_ROOT}/DiagonalLines.png
  ${ITK_EXAMPLE_DATA_ROOT}/DiagonalLines.png
  ${ITK_TEST_OUTPUT_DIR}/itkBSplineTransformTest2PixelCentered.png
  ${ITK_TEST_OUTPUT_DIR}/itkBSplineTransformTest2DeformationFieldPixelCentered.mhd
  1)
itk_add_test(
  NAME
  itkBSplineTransformTest3
  COMMAND
  ITKTransformTestDriver
  --compare
  DATA{Baseline/itkBSplineTransformTest3PixelCentered.png}
  ${ITK_TEST_OUTPUT_DIR}/itkBSplineTransformTest3PixelCentered.png
  itkBSplineTransformTest2
  ${ITK_EXAMPLE_DATA_ROOT}/BSplineDisplacements3.txt
  ${ITK_EXAMPLE_DATA_ROOT}/DiagonalLines.png
  ${ITK_EXAMPLE_DATA_ROOT}/DiagonalLines.png
  ${ITK_TEST_OUTPUT_DIR}/itkBSplineTransformTest3PixelCentered.png
  ${ITK_TEST_OUTPUT_DIR}/itkBSplineTransformTest3DeformationFieldPixelCentered.mhd
  2)
itk_add_test(
  NAME
  itkBSplineTransformTest4
  COMMAND
  ITKTransformTestDriver
  --compare
  DATA{Baseline/itkBSplineTransformTest4PixelCentered.png}
  ${ITK_TEST_OUTPUT_DIR}/itkBSplineTransformTest4PixelCentered.png
  itkBSplineTransformTest2
  ${ITK_EXAMPLE_DATA_ROOT}/BSplineDisplacements1.txt
  ${ITK_EXAMPLE_DATA_ROOT}/DiagonalLines.png
  ${ITK_EXAMPLE_DATA_ROOT}/DiagonalLines.png
  ${ITK_TEST_OUTPUT_DIR}/itkBSplineTransformTest4PixelCentered.png
  ${ITK_TEST_OUTPUT_DIR}/itkBSplineTransformTest4DeformationFieldPixelCentered.mhd
  3)
itk_add_test(
  NAME
  itkBSplineTransformTest5
  COMMAND
  ITKTransformTestDriver
  --compare
  DATA{Baseline/itkBSplineTransformTest4PixelCentered.png}
  ${ITK_TEST_OUTPUT_DIR}/itkBSplineTransformTest5PixelCentered.png
  itkBSplineTransformTest3
  ${ITK_EXAMPLE_DATA_ROOT}/BSplineDisplacements1.txt
  ${ITK_EXAMPLE_DATA_ROOT}/DiagonalLines.png
  ${ITK_EXAMPLE_DATA_ROOT}/DiagonalLines.png
  ${ITK_TEST_OUTPUT_DIR}/itkBSplineTransformTest5PixelCentered.png
  ${ITK_TEST_OUTPUT_DIR}/itkBSplineTransformTest5DeformationFieldPixelCentered.mhd
  0)
itk_add_test(
  NAME
  itkBSplineTransformTest6
  COMMAND
  ITKTransformTestDriver
  --compare
  DATA{Baseline/itkBSplineTransformTest4PixelCentered.png}
  ${ITK_TEST_OUTPUT_DIR}/itkBSplineTransformTest6PixelCentered.png
  itkBSplineTransformTest3
  ${ITK_EXAMPLE_DATA_ROOT}/BSplineDisplacements1.txt
  ${ITK_EXAMPLE_DATA_ROOT}/DiagonalLines.png
  ${ITK_EXAMPLE_DATA_ROOT}/DiagonalLines.png
  ${ITK_TEST_OUTPUT_DIR}/itkBSplineTransformTest6PixelCentered.png
  ${ITK_TEST_OUTPUT_DIR}/itkBSplineTransformTest6DeformationFieldPixelCentered.mhd
  1)
itk_add_test(
  NAME
  itkBSplineTransformTest7
  COMMAND
  ITKTransformTestDriver
  --compare
  DATA{Baseline/itkBSplineTransformTest4PixelCentered.png}
  ${ITK_TEST_OUTPUT_DIR}/itkBSplineTransformTest7PixelCentered.png
  itkBSplineTransformTest3
  ${ITK_EXAMPLE_DATA_ROOT}/BSplineDisplacements1.txt
  ${ITK_EXAMPLE_DATA_ROOT}/DiagonalLines.png
  ${ITK_EXAMPLE_DATA_ROOT}/DiagonalLines.png
  ${ITK_TEST_OUTPUT_DIR}/itkBSplineTransformTest7PixelCentered.png
  ${ITK_TEST_OUTPUT_DIR}/itkBSplineTransformTest7DeformationFieldPixelCentered.mhd
  2)
itk_add_test(
  NAME
  itkBSplineTransformInitializerTest1
  COMMAND
  ITKTransformTestDriver
  itkBSplineTransformInitializerTest1
  ${ITK_EXAMPLE_DATA_ROOT}/BSplineDisplacements1.txt
  ${ITK_EXAMPLE_DATA_ROOT}/BrainProtonDensitySliceBorder20.png

=== Modules/IO/BMP/wrapping/CMakeLists.txt ===
itk_wrap_module(ITKIOBMP)
itk_auto_load_and_end_wrap_submodules()

=== Modules/IO/JPEG2000/wrapping/CMakeLists.txt ===
itk_wrap_module(ITKIOJPEG2000)
itk_auto_load_and_end_wrap_submodules()

=== Modules/IO/MeshGifti/test/CMakeLists.txt ===
itk_module_test()

set(ITKIOMeshGiftiTests itkGiftiMeshIOTest.cxx itkMeshFileReadWriteTest.cxx)

createtestdriver(ITKIOMeshGifti "${ITKIOMeshGifti-Test_LIBRARIES}" "${ITKIOMeshGiftiTests}")

itk_add_test(
  NAME
  itkGiftiMeshIOTest1
  COMMAND
  ITKIOMeshGiftiTestDriver
  itkGiftiMeshIOTest
  DATA{Baseline/aparc.gii}
  ${ITK_TEST_OUTPUT_DIR}/giftimeshioaparc.gii
  DATA{${ITK_DATA_ROOT}/Input/tetrahedron.vtk}
  ${ITK_TEST_OUTPUT_DIR}/gifti2vtkaparc.vtk
  0
  1
  1
  1
  1
  0
  0
  1
  0
  131122
  0
  0
  1)
itk_add_test(
  NAME
  itkGiftiMeshIOTest2
  COMMAND
  ITKIOMeshGiftiTestDriver
  itkGiftiMeshIOTest
  DATA{Baseline/white.gii}
  ${ITK_TEST_OUTPUT_DIR}/giftimeshiowhite.gii
  DATA{${ITK_DATA_ROOT}/Input/tetrahedron.vtk}
  ${ITK_TEST_OUTPUT_DIR}/gifti2vtkwhite.vtk
  0
  1
  1
  1
  1
  0
  0
  1
  22134
  0
  44264
  0
  0)
itk_add_test(
  NAME
  itkMeshFileReadWriteTestGifti1
  COMMAND
  ITKIOMeshGiftiTestDriver
  itkMeshFileReadWriteTest
  DATA{Baseline/white.gii}
  ${ITK_TEST_OUTPUT_DIR}/white.gii)
itk_add_test(
  NAME
  itkMeshFileReadWriteTestGifti2
  COMMAND
  ITKIOMeshGiftiTestDriver
  itkMeshFileReadWriteTest
  DATA{Baseline/aparc.gii}
  ${ITK_TEST_OUTPUT_DIR}/aparc.gii)

=== Modules/IO/MeshOBJ/test/CMakeLists.txt ===
itk_module_test()

set(ITKIOMeshOBJTests itkMeshFileReadWriteTest.cxx itkOBJMeshIOTest.cxx)

createtestdriver(ITKIOMeshOBJ "${ITKIOMeshOBJ-Test_LIBRARIES}" "${ITKIOMeshOBJTests}")

itk_add_test(
  NAME
  itkMeshFileReadWriteOBJTest
  COMMAND
  ITKIOMeshOBJTestDriver
  itkMeshFileReadWriteTest
  DATA{Baseline/box.obj}
  ${ITK_TEST_OUTPUT_DIR}/box.obj)

itk_add_test(
  NAME
  itkMeshFileReadWriteOBJWithPointDataTest
  COMMAND
  ITKIOMeshOBJTestDriver
  itkMeshFileReadWriteTest
  DATA{Baseline/bunny.obj}
  ${ITK_TEST_OUTPUT_DIR}/bunny.vtk)

itk_add_test(
  NAME
  itkOBJMeshIOTest1
  COMMAND
  ITKIOMeshOBJTestDriver
  itkOBJMeshIOTest
  DATA{Baseline/box.obj}
  ${ITK_TEST_OUTPUT_DIR}/objmeshiobox.obj
  DATA{${ITK_DATA_ROOT}/Input/tetrahedron.vtk}
  ${ITK_TEST_OUTPUT_DIR}/obj2vtkbox.vtk
  0
  1
  1
  1
  1
  8
  0
  6
  0)

itk_add_test(
  NAME
  itkOBJMeshIOTest2
  COMMAND
  ITKIOMeshOBJTestDriver
  itkOBJMeshIOTest
  DATA{Baseline/bunny.obj}
  ${ITK_TEST_OUTPUT_DIR}/objmeshiobunny.obj
  DATA{${ITK_DATA_ROOT}/Input/tetrahedron.vtk}
  ${ITK_TEST_OUTPUT_DIR}/obj2vtkbunny.vtk
  0
  1
  1
  1
  1
  2503
  4968
  4968
  0)

=== Modules/Numerics/Optimizers/src/CMakeLists.txt ===
set(ITKOptimizers_SRCS
    itkNonLinearOptimizer.cxx
    itkMultipleValuedCostFunction.cxx
    itkSingleValuedCostFunction.cxx
    itkConjugateGradientOptimizer.cxx
    itkRegularStepGradientDescentOptimizer.cxx
    itkLBFGSOptimizer.cxx
    itkExhaustiveOptimizer.cxx
    itkLevenbergMarquardtOptimizer.cxx
    itkSingleValuedNonLinearVnlOptimizer.cxx
    itkQuaternionRigidTransformGradientDescentOptimizer.cxx
    itkSPSAOptimizer.cxx
    itkSingleValuedVnlCostFunctionAdaptor.cxx
    itkMultipleValuedNonLinearVnlOptimizer.cxx
    itkPowellOptimizer.cxx
    itkVersorTransformOptimizer.cxx
    itkOnePlusOneEvolutionaryOptimizer.cxx
    itkMultipleValuedNonLinearOptimizer.cxx
    itkLBFGSBOptimizer.cxx
    itkCumulativeGaussianOptimizer.cxx
    itkAmoebaOptimizer.cxx
    itkCumulativeGaussianCostFunction.cxx
    itkOptimizer.cxx
    itkFRPROptimizer.cxx
    itkGradientDescentOptimizer.cxx
    itkSingleValuedNonLinearOptimizer.cxx
    itkRegularStepGradientDescentBaseOptimizer.cxx
    itkMultipleValuedVnlCostFunctionAdaptor.cxx
    itkParticleSwarmOptimizerBase.cxx
    itkParticleSwarmOptimizer.cxx
    itkInitializationBiasedParticleSwarmOptimizer.cxx)

itk_module_add_library(ITKOptimizers ${ITKOptimizers_SRCS})
target_link_libraries(ITKOptimizers LINK_PUBLIC ${ITKTransform_LIBRARIES})

=== Modules/Filtering/ImageFilterBase/wrapping/test/CMakeLists.txt ===
# some tests will fail if dim=2 and unsigned short are not wrapped
list(
  FIND
  ITK_WRAP_IMAGE_DIMS
  2
  wrap_2_index)
if(ITK_WRAP_PYTHON
   AND ITK_WRAP_unsigned_char
   AND wrap_2_index GREATER -1)
  itk_python_add_test(
    NAME
    PythonCastImageFilterTest
    TEST_DRIVER_ARGS
    --compare
    ${ITK_TEST_OUTPUT_DIR}/PythonCastImageFilterTest.png
    DATA{${ITK_DATA_ROOT}/Input/cthead1.png}
    COMMAND
    ${CMAKE_CURRENT_SOURCE_DIR}/CastImageFilterTest.py
    DATA{${ITK_DATA_ROOT}/Input/cthead1.png}
    ${ITK_TEST_OUTPUT_DIR}/PythonCastImageFilterTest.png)
endif()

=== PKGBUILD ===
# Maintainer: Sergey Popov <popov.sa@gmail.com>

_realname=itk
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=5.4.2
pkgrel=4
pkgdesc='An open-source C++ toolkit for medical image processing (mingw-w64)'
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url='https://www.itk.org/'
msys2_repository_url="https://github.com/InsightSoftwareConsortium/ITK"
msys2_references=(
  'aur: itk'
)
license=('spdx:Apache-2.0')
depends=("${MINGW_PACKAGE_PREFIX}-cc-libs"
         "${MINGW_PACKAGE_PREFIX}-dcmtk"
         "${MINGW_PACKAGE_PREFIX}-double-conversion"
         "${MINGW_PACKAGE_PREFIX}-expat"
         "${MINGW_PACKAGE_PREFIX}-fftw"
         "${MINGW_PACKAGE_PREFIX}-gdcm"
         "${MINGW_PACKAGE_PREFIX}-hdf5"
         "${MINGW_PACKAGE_PREFIX}-libjpeg"
         "${MINGW_PACKAGE_PREFIX}-libpng"
         "${MINGW_PACKAGE_PREFIX}-libtiff"
         #"${MINGW_PACKAGE_PREFIX}-opencl-icd"
         "${MINGW_PACKAGE_PREFIX}-zlib")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-eigen3"
             "${MINGW_PACKAGE_PREFIX}-gtest"
             "${MINGW_PACKAGE_PREFIX}-opencv"
             "${MINGW_PACKAGE_PREFIX}-vtk"
             "${MINGW_PACKAGE_PREFIX}-adios2"
             $([[ ${MSYSTEM} == MINGW64 ]] || echo "${MINGW_PACKAGE_PREFIX}-anari-sdk")
             "${MINGW_PACKAGE_PREFIX}-cgns"
             "${MINGW_PACKAGE_PREFIX}-ffmpeg"
             "${MINGW_PACKAGE_PREFIX}-cli11"
             "${MINGW_PACKAGE_PREFIX}-fast_float"
             "${MINGW_PACKAGE_PREFIX}-gdal"
             "${MINGW_PACKAGE_PREFIX}-gl2ps"
             "${MINGW_PACKAGE_PREFIX}-libmariadbclient"
             "${MINGW_PACKAGE_PREFIX}-liblas"
             "${MINGW_PACKAGE_PREFIX}-libogg"
             "${MINGW_PACKAGE_PREFIX}-libtheora"
             "${MINGW_PACKAGE_PREFIX}-opencascade"
             "${MINGW_PACKAGE_PREFIX}-openslide"
             "${MINGW_PACKAGE_PREFIX}-openturns"
             "${MINGW_PACKAGE_PREFIX}-openvdb"
             "${MINGW_PACKAGE_PREFIX}-openvr"
             "${MINGW_PACKAGE_PREFIX}-pdal"
             "${MINGW_PACKAGE_PREFIX}-proj"
             "${MINGW_PACKAGE_PREFIX}-python"
             "${MINGW_PACKAGE_PREFIX}-qt6-base"
             "${MINGW_PACKAGE_PREFIX}-qt6-declarative"
             "${MINGW_PACKAGE_PREFIX}-unixodbc"
             "${MINGW_PACKAGE_PREFIX}-utf8cpp")
optdepends=("${MINGW_PACKAGE_PREFIX}-opencv: ITK-OpenCV bridge"
            "${MINGW_PACKAGE_PREFIX}-vtk: ITK-VTK bridge")
source=("https://github.com/InsightSoftwareConsortium/ITK/archive/v${pkgver}/ITK-${pkgver}.tar.gz"
        https://github.com/InsightSoftwareConsortium/ITK/commit/4f275769e37fa29754166c7eded2d84c0b33991a.patch
        libminc-pr-129.patch)
sha256sums=('931c4edf7ae57eede3fc611992941edce64bea508cf5c8741c2a4c2f56eceff1'
            'a66b459b42f4daeffc0278af16b20ea12f765f237f38844cba8f6957580424bb'
            '14c1fe4b41fa77aed8483dbece655740dd485e8d78184c9351063a5fb77fa0b4')

prepare() {
  cd "ITK-${pkgver}"
  patch -p1 -i "${srcdir}"/4f275769e37fa29754166c7eded2d84c0b33991a.patch
  patch -p1 -i "${srcdir}"/libminc-pr-129.patch
}

build() {
  local -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  if [[ ${CARCH} == x86_64 ]]; then
    _extra_config+=("-DVNL_CONFIG_ENABLE_SSE2_ROUNDING=ON")
  else
    _extra_config+=("-DVNL_CONFIG_ENABLE_SSE2_ROUNDING=OFF")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  cmake \
    -GNinja \
    -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
    -DBUILD_SHARED_LIBS=ON \
    -DBUILD_DOCUMENTATION=OFF \
    -DBUILD_EXAMPLES=OFF \
    -DBUILD_TESTING=OFF \
    -DITK_INSTALL_INCLUDE_DIR=include/ITK \
    -DITK_INSTALL_DATA_DIR=share/ITK \
    -DITK_INSTALL_DOC_DIR=share/doc/ITK \
    -DITK_INSTALL_PACKAGE_DIR=lib/cmake/ITK \
    -DITK_CUSTOM_LIBRARY_SUFFIX="" \
    -DITK_LEGACY_REMOVE=ON \
    -DITK_FUTURE_LEGACY_REMOVE=ON \
    -DITK_BUILD_DEFAULT_MODULES=OFF \
    -DITKGroup_Core=ON \
    -DITKGroup_IO=$([[ ${MINGW_PACKAGE_PREFIX} != *-clang-* ]] && echo "ON" || echo "OFF") \
    -DITKGroup_Filtering=ON \
    -DITKGroup_Registration=ON \
    -DITKGroup_Segmentation=ON \
    -DITKGroup_Numerics=ON \
    -DITKGroup_Video=ON \
    -DITKGroup_ThirdParty=ON \
    -DITKGroup_Bridge=ON \
    -DITKGroup_Nonunit=$([[ ${MINGW_PACKAGE_PREFIX} != *-clang-* ]] && echo "ON" || echo "OFF") \ \
    -DITKGroup_Compatibility=ON \
    -DModule_ITKVideoBridgeOpenCV=ON \
    -DModule_ITKVtkGlue=ON \
    -DITK_USE_GPU=OFF \
    -DUSE_FFTWD=ON \
    -DUSE_FFTWF=ON \
    -DITK_USE_SYSTEM_LIBRARIES=ON \
    -DITK_USE_SYSTEM_DCMTK=ON \
    -DITK_USE_SYSTEM_DOUBLECONVERSION=ON \
    -DITK_USE_SYSTEM_EIGEN=ON \
    -DITK_USE_SYSTEM_EXPAT=ON \
    -DITK_USE_SYSTEM_FFTW=ON \
    -DITK_USE_SYSTEM_GDCM=ON \
    -DITK_USE_SYSTEM_GOOGLETEST=ON \
    -DITK_USE_SYSTEM_HDF5=ON \
    -DITK_USE_SYSTEM_JPEG=ON \
    -DITK_USE_SYSTEM_MINC=OFF \
    -DITK_USE_SYSTEM_PNG=ON \
    -DITK_USE_SYSTEM_TIFF=ON \
    -DITK_USE_SYSTEM_VXL=OFF \
    -DITK_USE_SYSTEM_ZLIB=ON \
    -DITK_SKIP_PATH_LENGTH_CHECKS=1 \
    -DITK_FORBID_DOWNLOADS=ON \
    -DVNL_CONFIG_THREAD_SAFE=ON \
    -DPython3_EXECUTABLE=${MINGW_PREFIX}/bin/python \
    "${_extra_config[@]}" \
    -S "ITK-${pkgver}" \
    -B "build-${MSYSTEM}"

  cmake --build "build-${MSYSTEM}"
}

package() {
  DESTDIR="${pkgdir}" cmake --install "build-${MSYSTEM}"

  local PREFIX_DEPS=$(cygpath -am ${MINGW_PREFIX})
  sed -s "s|${PREFIX_DEPS}|\${_IMPORT_PREFIX}|g" \
    -i "${pkgdir}${MINGW_PREFIX}/lib/cmake/${_realname}/ITKTargets-release.cmake"
  find "${pkgdir}${MINGW_PREFIX}/lib/cmake/${_realname}" -name '*.cmake' -exec \
    sed -s "s|${PREFIX_DEPS}|\${ITK_INSTALL_PREFIX}|g" -i {} \;

  install -Dm644 "ITK-${pkgver}/LICENSE" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE"
  install -Dm644 "ITK-${pkgver}/NOTICE" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/NOTICE"
  install -Dm644 "ITK-${pkgver}/Modules/ThirdParty/KWSys/src/KWSys/Copyright.txt" \
    "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/KWSys/Copyright.txt"
}
